Subject: Re: http.sslVersion only specifies minimum TLS version, later versions are allowed

From: Daniel Carpenter <[email-masked]>
Date: Mon, 3 May 2021 15:02:10 +0000

> On Mon, May 03, 2021 at 03:55:31PM +0200, Ævar Arnfjörð Bjarmason wrote:
> 
> > On Mon, May 03 2021, Daniel Carpenter wrote:
> >
> > > When I run: "GIT_SSL_VERSION=tlsv1.2 GIT_CURL_VERBOSE=T git clone https://github.com/git/git.git"
> > >
> > > I see: "SSL connection using TLS1.3 / ECDHE_RSA_AES_128_GCM_SHA256", but I was expecting to see "TLS1.2".
> >
> > I think you're right per the documentation, but I wonder if the current
> > behavior isn't more useful for most users. I.e. are there really users
> > who want exactly 1.2 and not 1.3, 1.4 etc. in the future that aren't
> > dealing with an issue like what you're encountering?
> >
> > I.e. the "better security in the future by default" seems like a
> > better/more common case than "pin to this forever" in this case, no?
> >
> > We should of course have a way to pin it, but given the current behavior
> > I wonder if we shouldn't just change the documentation, and introduce
> > support for e.g. "=tlsv1.1" etc, or a http.pinSSLVersion=tls1.1 or
> > something...
> 
> Just looking at how the curl binary does it, "--tlsv1.2" means "1.2 or
> greater" (which is not at all surprising; the library interface tends to
> mirror their command-line and vice versa, and our behavior is influenced
> by the library interface here).  But that implies to me that curl folks
> considered this and though the "or greater" behavior was useful (which
> makes sense -- the main goal is probably to avoid insecurities in older
> versions of the protocol).
> 
> Anyway, the binary also has --tls-max for capping the maximum version.
> That seems more flexible in general than "use this version exactly" (if
> you only care that 1.3 is broken, then setting "max=1.2" lets you talk
> to servers that support 1.1 or 1.2).
> 
> -Peff

I agree that the current behaviour is better for most users, and that some kind of separate "max" config option would work for anyone in my situation.

Another idea would be to keep the current behaviour for `http.sslVersion`, but use an exact match with the environment variable only. That already takes priority, and I imagine its main appeal over the config option is for users that want to try something with a specific TLS version.